#include"stdio.h"
#include"cstring"
#include <initializer_list>
#include <array>
#include"cassert"
#define mini(x,y) if(y<x)x=y;
int primes[] = {2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,510};
void solve() {
    int r, c, final_ans = 0;
    scanf("%d%d", &r, &c);
    char mat[r][c+1];
    char ans[r][c];
    for(int i=0; i<r; i++) {
        scanf("%s", mat[i]);
        for(int j=0; j<c; j++)
            ans[i][j]=mat[i][j]=='^'?100:0;
    }
    if(r<5 or c<5){printf("0\n"); return;}
    const std::array<int, 6> dir1 = {0,0,0,1,c,r}, dir2 = {0,0,1,0,r,c}, dir3 = {r-1,c-1,-1,0,r,c}, dir4 = {r-1,c-1,0,-1,c,r};
    for(const auto dir: {dir1, dir2, dir3, dir4}) {
        int i=dir[0], j=dir[1],  outer_count=dir[5];
        const int i_inc=dir[2], j_inc=dir[3], inner_count=dir[4];
        while(outer_count--) {
            int pr=0, cnt=0, i_c = i, j_c=j, loop_cnt = inner_count;
            while(loop_cnt--) {
                mini(ans[i_c][j_c], pr);
                if(mat[i_c][j_c]=='^')cnt++; else cnt=pr=0;
                if(cnt==primes[pr])pr++;
                i_c += i_inc, j_c += j_inc;
            }
            i += j_inc, j+= i_inc;
        }
    }
    for(int i=r-1;--i;)for(int j=c-1; --j;)
        final_ans += ans[i][j];
    printf("%d\n", final_ans);
}
int main() {
    int T;
    scanf("%d", &T);
    while(T--)
        solve();
}
